﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace MutexGruppiProcessi
{
    class Program
    {
        const int NumClienti = 20;
        const int RitardoCliente = 1300;                // ms
        const int RitardoStilista = 2000;               // ms
        const int DurataAcquistoCliente = 1200;         // ms
        const int DurataLavoroStilista = 2000;          // ms
        static readonly string[] articoli = new string[]
        {
            "Stivali rossi",
            "Giacca blu",
            "Camicia bianca",
            "Cintura verde",
            "Guanti neri",
            "Cappotto grigio"
        };
        static SemaphoreSlim mutex = new SemaphoreSlim(1);
        static int moda = 0;
        static SemaphoreSlim mutexGruppo = new SemaphoreSlim(1);
        static int processiGruppoDentro = 0;
        static void Main(string[] args)
        {
            List<Task> lista = new List<Task>();

            lista.Add(Task.Factory.StartNew(() =>
            {
                ElaboraStilista();
            }, TaskCreationOptions.LongRunning));

            for (int i = 0; i < NumClienti; i++)
            {
                int idCliente = i;
                Thread.Sleep(RitardoCliente);
                lista.Add(Task.Factory.StartNew(() =>
                {
                    ElaboraCliente(idCliente);
                }, TaskCreationOptions.LongRunning));
            }

            Task.WaitAll(lista.ToArray());
        }

        static void ElaboraCliente(int id)
        {
            Console.WriteLine("Il cliente n. {0} è giunto al negozio.", id);

            mutexGruppo.Wait();
            processiGruppoDentro++;
            if (processiGruppoDentro == 1)
                mutex.Wait();
            Console.WriteLine("Il cliente n. {0} è entrato. Nel negozio ci sono ora {1} clienti.", id, processiGruppoDentro);
            mutexGruppo.Release();

            Thread.Sleep(DurataAcquistoCliente);
            Console.WriteLine("Il cliente n. {0} ha acquistato: {1}", id, articoli[moda]);

            mutexGruppo.Wait();
            processiGruppoDentro--;
            if (processiGruppoDentro == 0)
                mutex.Release();
            Console.WriteLine("Il cliente n. {0} è uscito. Nel negozio ci sono ora {1} clienti.", id, processiGruppoDentro);
            mutexGruppo.Release();
        }

        static void ElaboraStilista()
        {
            const int NumVolteStilista = 5;
            for (int i = 0; i < NumVolteStilista; i++)
            {
                Thread.Sleep(RitardoStilista);
                Console.WriteLine("Lo stilista desidera creare un nuovo articolo.", i);

                mutex.Wait();

                Console.WriteLine("Lo stilista si è messo al lavoro.", i);
                Thread.Sleep(DurataLavoroStilista);
                moda++;
                if (moda == articoli.Length)
                    moda = 0;
                Console.WriteLine("***** LO STILISTA HA CREATO UN NUOVO ARTICOLO: {0}", articoli[moda]);

                mutex.Release();
            }

        }

    }
}
