﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Rendez_Vous
{
    class Program
    {
        const int Lunghezza = 100;
        static int[] V = new int[Lunghezza];
        static int[] W = new int[Lunghezza];
        static SemaphoreSlim mutex1 = new SemaphoreSlim(0);
        static SemaphoreSlim mutex2 = new SemaphoreSlim(0);
        static void Main(string[] args)
        {
            Parallel.Invoke(Attivita1, Attivita2);
        }

        static void Attivita1()
        {
            Random r = new Random(2018);
            int minimo;
            // Prima parte: inserimento di valori casuali in V
            for (int i = 0; i < Lunghezza; i++)
                V[i] = r.Next(1000);            // Numeri casuali minori di 1000

            mutex1.Release();       // Segnala la fine della prima parte di "Attività 1"
            mutex2.Wait();          // In attesa del completamento della prima parte di  "Attività 2"

            // Seconda parte: determinazione del valore di minimo
            minimo = Math.Min(V.Min(), W.Min());
            Console.WriteLine("Valore minimo contenuto in V,W: {0}", minimo);
        }
        static void Attivita2()
        {
            Random r = new Random(2019);
            int somma;
            double media;
            // Prima parte: inserimento di valori casuali in V
            for (int i = 0; i < Lunghezza; i++)
                W[i] = r.Next(1000);

            mutex2.Release();       // Segnala la fine della prima parte di "Attività 2"
            mutex1.Wait();          // In attesa del completamento della prima parte di  "Attività 1"

            // Seconda parte: determinazione della media aritmetica
            somma = V.Sum() + W.Sum();
            media = somma / (double)(V.Length + W.Length);
            Console.WriteLine("Media degli elementi contenuti in V,W: {0:N2}", media);
        }
    }
}
